<!-- vim: set spelllang=fr: -->

# À la recherche des notes originelles

À partir de l’enregistrement numérique d’une interprétation musicale, est-il possible de reconnaître la séquence de notes qui a été jouée sur les différents instruments utilisés ?
Cette situation s’apparente à celle où l’on dispose d’une image matricielle rendue à partir d’une image vectorielle et où l’on souhaite retrouver les vecteurs d’origine dont on ne dispose plus — à la différence que nous traitons ici d’un signal 1D au lieu de 2D, et d’un signal sonore plutôt que visuel qui plus est.

## Excursion sinusoïdale

Simplifions d’abord le problème en considérant [un signal composé uniquement de sinusoïdes pures](sounds/synth.wav) (produit par le synthétiseur de fortune qu’est [ce script Python](generate.py)).
Cela facilite doublement la tâche, puisque non seulement le signal est totalement exempt de bruit, mais en plus les instruments convoqués n’ont qu’une seule harmonique.
Une première approche consiste à étudier le spectre du signal en utilisant une [transformation de Fourier](https://fr.wikipedia.org/wiki/Transformation_de_Fourier_discrète) (générée par [ce script Python](analyze-single.py)).

![Spectre du son produit par le synthétiseur](fig/synth-single.png)

Ce spectre permet de lire les différentes fréquences qui composent le son étudié.
On y distingue, parmi les fréquences les plus représentées, un *sol₂* (192 Hz), un *do₂* (131 Hz), un *la₂* (220 Hz) et un *la₃* (440 Hz).
Une information cruciale manque, celle de l’évolution du signal dans le temps.
Une façon de l’obtenir consiste à découper le signal en courtes fenêtres de temps et d’appliquer la transformation de Fourier sur les morceaux obtenus : c’est [la transformée de Fourier à court terme](https://fr.wikipedia.org/wiki/Transform%C3%A9e_de_Fourier_%C3%A0_court_terme).
On obtient ainsi un [sonagramme](https://fr.wikipedia.org/wiki/Sonagramme) qui montre l’évolution des fréquences du signal dans le temps (produit par [ce script Python](analyze-shorttime.py)).

![Évolution dans le temps du spectre du son produit par le synthétiseur](fig/synth-shorttime.png)

Ce sonagramme permet de distinguer clairement les deux parties du morceau, celle jouée par une sinusoïde au dessus de 250 Hz et celle jouée par une onde carrée en dessous de cette fréquence.
On reconnaît également les quatre accords en do majeur joués par la sinusoïde deux fois de suite.
Sur cet exemple simple, la transformée de Fourier à court terme est donc suffisante pour extraire les notes, mais qu’en est-il d’un signal plus complexe ?
